//###########################################################################//
//
//Title :  Example 1 of 3d Programming  
//
//Author:  David Coz      
//
//Mail  :  coz.hubert@infonie.fr
//
// Display a Cube 
//
//Created 13/04/2002; 00:21:07
//
//############################################################################//




#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files





//Structure for Vertex (3D point)
typedef struct
{

    int x;
    int y;
    int z;
  
} Vertex;

//Structure fo Screen Point(2D point)
typedef struct
{

    int x;
    int y;
      
} ScrPoint;






// Main Function
void _main(void)
{

//define the Screen Center for a ti 89
ScrPoint Screen_center= { 80 , 50 };

//define the perspective Distorsion
int Distorsion = 80 ;

int  p , l ;

ClrScr();

//vertices definition of the cube 
Vertex CUBE [8] = { {-10,-10,-10},{10,-10,-10},{10,10,-10},{-10,10,-10},
                     {-10,-10,10}, {10,-10,10}, {10,10,10},{-10,10,10} };

//Lines that join the Vertices
int LINES [12] [2] = { {0,1} , {1,2} , {2,3} , {3,0} , {4,5} , {5,6} , {6,7} , {7,4} ,      
                   {0,4} , {1,5} , {2,6} , {3,7} } ;  


//It will represent the Vertices on the Screen
ScrPoint SP_CUBE [8] ; 

//Store Vertices after transformations
Vertex Work;

//Camera Position
Vertex Camera = {0,0,50};

 for (p=0 ; p<8 ;p++) // For the 8 points...
{

	// Store the values in Work
	
	Work .x = CUBE [p].x - Camera.x;
	Work .y = CUBE [p].y - Camera.y;
	Work .z = CUBE [p].z - Camera.z;
	
	// Calculate the ScrPoints...
	
	SP_CUBE[p].x = Screen_center.x + (Distorsion * Work .x )/ Work .z ;
	SP_CUBE[p].y = Screen_center.y - (Distorsion * Work .y )/ Work .z ;

}

//Now that we have the ScrPoints,we must draw the lines on the screen...


int P1_x , P2_x , P1_y , P2_y ;// Intermediate values...

 for (l=0 ; l<12 ;l++)  // For the 12 lines...
{
		P1_x = SP_CUBE [ LINES [l] [0] ].x ; // First Point x value...
		P1_y = SP_CUBE [ LINES [l] [0] ].y ; // First Point y value...
		P2_x = SP_CUBE [ LINES [l] [1] ].x ; // Second Point x value...
		P2_y = SP_CUBE [ LINES [l] [1] ].y ; // Second Point y value...
		
		//Now draw the line between the 2 points...
		
		DrawLine ( P1_x , P1_y , P2_x , P2_y , A_NORMAL );
		 
}

ngetchx();

}


//  by David Coz      coz.hubert@infonie.fr
